import com.fasterxml.jackson.annotation.JsonInclude
import com.fasterxml.jackson.databind.annotation.JsonSerialize
import com.fasterxml.jackson.module.kotlin.*

data class Transaction(val cost: Money,
                       val category: String,
                       val subcategory: String = "",
                       val location: String,
                       val timestamp: String) {
    fun serialize(): String {
        val mapper = jacksonObjectMapper().registerModule(KotlinModule())
        return mapper.writeValueAsString(this)
    }

    companion object {
        fun fromJSON(x: String): Transaction {
            val mapper = jacksonObjectMapper().registerModule(KotlinModule())
            return mapper.readValue(x)
        }
    }
}
